<section class="panel-container">

    <div class="panel-header">
        <span class="panel-title">{{data?.product?.name ? (data?.product?.name | titlecase) : 'New Product'}}</span>
        <mat-icon class="panel-close" mat-dialog-close>close</mat-icon>
    </div>

    <div class="panel-summary">
        You can add or modify a stripe product here.
    </div>

    <div class="panel-content">
        <form [formGroup]="productForm" autocomplete="off" class="d-flex flex-wrap justify-content-between">
            <mat-form-field appearance="outline" class="flex-grow-1 ml-2">
                <mat-label>Name</mat-label>
                <input formControlName="name" matInput>
                <mat-error *ngIf="productForm.controls.name.hasError('required')">Name is required</mat-error>
            </mat-form-field>

            <mat-slide-toggle class="flex-grow-1 ml-2 mt-3"
                              color="primary"
                              formControlName="active">
                Active
            </mat-slide-toggle>


            <mat-form-field appearance="outline" class="flex-grow-1 ml-2">
                <mat-label>id</mat-label>
                <input formControlName="id" matInput>
            </mat-form-field>

            <mat-form-field appearance="outline" class="flex-grow-1 ml-2">
                <mat-label>Description</mat-label>
                <input formControlName="description" matInput>
            </mat-form-field>

            <mat-form-field [appearance]="'outline'" class="flex-grow-1 ml-2">
                <mat-label>Type</mat-label>
                <mat-select formControlName="type">
                    <mat-option value="service">service</mat-option>
                    <mat-option value="good">good</mat-option>
                </mat-select>
            </mat-form-field>

            <mat-form-field appearance="outline" class="flex-grow-1 ml-2" *ngIf="productForm.controls.type.value !== 'good'">
                <mat-label>Statement Descriptor</mat-label>
                <input formControlName="statement_descriptor" matInput>
            </mat-form-field>

            <mat-form-field *ngIf="productForm.controls.type.value !== 'good'" appearance="outline"
                            class="flex-grow-1 ml-2">
                <mat-label>Unit Label</mat-label>
                <input formControlName="unit_label" matInput>
            </mat-form-field>

            <mat-slide-toggle *ngIf="productForm.controls.type.value === 'good'" class="flex-grow-1 ml-2 mt-3"
                              color="primary"
                              formControlName="shippable">
                Shippable
            </mat-slide-toggle>

            <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline"
                            class="flex-grow-1 ml-2">
                <mat-label>URL</mat-label>
                <input formControlName="url" matInput>
            </mat-form-field>

            <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline" class="w-100 ml-2">
                <mat-label>Attributes</mat-label>
                <mat-chip-list #tagList>
                    <mat-chip (removed)="removeTag(tag, 'attributes')"
                              *ngFor="let tag of attributes" [removable]="true">
                        {{tag}}
                        <mat-icon matChipRemove>cancel</mat-icon>
                    </mat-chip>
                    <input (matChipInputTokenEnd)="addTag($event, 'attributes')"
                           [matChipInputAddOnBlur]="true"
                           [matChipInputFor]="tagList"
                           [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
                           placeholder="+ Attr">
                </mat-chip-list>
            </mat-form-field>

            <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline" class="w-100 ml-2 mb-2">
                <mat-label>Deactivate On</mat-label>
                <mat-chip-list #tagList2>
                    <mat-chip (removed)="removeTag(tag, 'deactivate_on')"
                              *ngFor="let tag of deactivate_on" [removable]="true">
                        {{tag}}
                        <mat-icon matChipRemove>cancel</mat-icon>
                    </mat-chip>
                    <input (matChipInputTokenEnd)="addTag($event, 'deactivate_on')"
                           [matChipInputAddOnBlur]="true"
                           [matChipInputFor]="tagList2"
                           [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
                           placeholder="+ ID">
                </mat-chip-list>
                <mat-hint> (optional) Deactivate on Connect applications (they must exist in your Stripe Connect)</mat-hint>
            </mat-form-field>

            <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline" class="w-100 ml-2">
                <mat-label>Image URLs</mat-label>
                <mat-chip-list #tagList3>
                    <mat-chip (removed)="removeTag(tag, 'images')"
                              *ngFor="let tag of images" [removable]="true">
                        {{tag}}
                        <mat-icon matChipRemove>cancel</mat-icon>
                    </mat-chip>
                    <input (matChipInputTokenEnd)="addTag($event, 'images')"
                           [matChipInputAddOnBlur]="true"
                           [matChipInputFor]="tagList3"
                           [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
                           placeholder="+ url">
                </mat-chip-list>
                <mat-hint matSuffix>Max of 5 urls</mat-hint>
            </mat-form-field>

            <div *ngIf="productForm.controls.type.value === 'good'" class="m-0 p-0" formGroupName="package_dimensions">
                <p><b>Package Dimensions</b></p>
                <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline"
                                class="flex-grow-1 ml-2">
                    <mat-label>Height</mat-label>
                    <input formControlName="height" matInput min="0" step="0.01" type="number">
                </mat-form-field>

                <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline"
                                class="flex-grow-1 ml-2">
                    <mat-label>Length</mat-label>
                    <input formControlName="length" matInput min="0" step="0.01" type="number">
                </mat-form-field>

                <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline"
                                class="flex-grow-1 ml-2">
                    <mat-label>width</mat-label>
                    <input formControlName="width" matInput min="0" step="0.01" type="number">
                </mat-form-field>

                <mat-form-field *ngIf="productForm.controls.type.value === 'good'" appearance="outline"
                                class="flex-grow-1 ml-2">
                    <mat-label>weight</mat-label>
                    <input formControlName="weight" matInput min="0" step="0.01" type="number">
                </mat-form-field>
            </div>

            <div class="w-100">
                <div class="w-100 d-flex">
                    <div><b>Metadata</b></div>
                    <div class="ml-auto">
                        <mat-icon class="cursor-pointer" (click)="addMetadata()">add</mat-icon>
                    </div>
                </div>
                <table mat-table [dataSource]="metaData" class="w-100 panel-table">
                    <ng-container matColumnDef="key">
                        <th mat-header-cell *matHeaderCellDef>key</th>
                        <td mat-cell *matCellDef="let row">
                            <mat-form-field appearance="outline">
                                <input matInput type="text" [value]="row.key"
                                       (change)="row.key = $event.target['value']">
                            </mat-form-field>
                        </td>
                    </ng-container>
                    <ng-container matColumnDef="value">
                        <th mat-header-cell *matHeaderCellDef>Value</th>
                        <td mat-cell *matCellDef="let row">
                            <mat-form-field appearance="outline">
                                <input matInput type="text" [value]="row.value"
                                       (change)="row.value = $event.target['value']">
                            </mat-form-field>
                        </td>
                    </ng-container>

                    <ng-container matColumnDef="remove">
                        <th mat-header-cell *matHeaderCellDef>Remove</th>
                        <td mat-cell *matCellDef="let row">
                            <mat-icon (click)="removeMetadata(row)" class="cursor-pointer">delete</mat-icon>
                        </td>
                    </ng-container>

                    <tr mat-header-row
                        *matHeaderRowDef="['key', 'value', 'remove']"></tr>
                    <tr mat-row
                        *matRowDef="let row; columns: ['key', 'value', 'remove'];"></tr>
                </table>
            </div>
        </form>
    </div>

    <div class="panel-footer">
        <button mat-flat-button color="warn" (click)="deleteProduct()" class="mr-auto" *ngIf="data?.product">
            <mat-icon>delete</mat-icon>
        </button>
        <button (click)="submit()" mat-flat-button>{{data?.product ? 'Update' : 'Submit'}}</button>
    </div>
</section>
